| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Member Functions | List of all members
TagCollectionSvc Class Reference

Gaudi tag collection service definition. More...

`#include <src/NTupleSvc/TagCollectionSvc.h>`

Inheritance diagram for TagCollectionSvc:
[legend]
Collaboration diagram for TagCollectionSvc:
[legend]

## Public Member Functions
| TagCollectionSvc (const std::string &name, ISvcLocator *svc)
| Standard Constructor. More...
StatusCode | connect (const std::string &ident) override
| unhides some NTupleSvc methods More...
StatusCode | connect (const std::string &ident, std::string &logname) override
| unhides some NTupleSvc methods More...
Public Member Functions inherited from NTupleSvc
StatusCode | initialize () override
| DataSvc overrides: Initialize the service. More...
StatusCode | reinitialize () override
| DataSvc overrides: reinitialize service. More...
StatusCode | finalize () override
| DataSvc overrides: stop the service. More...
IConversionSvc * | getDataLoader (IRegistry *pReg) override
| DataSvc overrides: Retrieve data loader. More...
NTuple::Directory * | createDirectory (DataObject *pParent, const std::string &title) override
| Create Ntuple directory and register it with the data store. More...
NTuple::Directory * | createDirectory (DataObject *pParent, long id) override
| Create Ntuple directory and register it with the data store. More...
NTuple::Directory * | createDirectory (const std::string &dirPath, long id) override
| Create Ntuple directory and register it with the data store. More...
NTuple::Directory * | createDirectory (const std::string &dirPath, const std::string &title) override
| Create Ntuple directory and register it with the data store. More...
NTuple::Directory * | createDirectory (const std::string &fullPath) override
| Create Ntuple directory and register it with the data store. More...
StatusCode | create (const CLID &typ, const std::string &title, NTuple::Tuple *&refpTuple) override
| Create requested N tuple (Hide constructor) More...
NTuple::Tuple * | book (const std::string &fullPath, const CLID &type, const std::string &title) override
| Book Ntuple and register it with the data store. More...
NTuple::Tuple * | book (const std::string &dirPath, const std::string &relPath, const CLID &type, const std::string &title) override
| Book Ntuple and register it with the data store. More...
NTuple::Tuple * | book (const std::string &dirPath, long id, const CLID &type, const std::string &title) override
| Book Ntuple and register it with the data store. More...
NTuple::Tuple * | book (DataObject *pParent, const std::string &relPath, const CLID &type, const std::string &title) override
| Book Ntuple and register it with the data store. More...
NTuple::Tuple * | book (DataObject *pParent, long id, const CLID &type, const std::string &title) override
| Book Ntuple and register it with the data store. More...
NTuple::Tuple * | access (const std::string &fullPath, const std::string &filename) override
| Access N tuple on disk. More...
StatusCode | save (const std::string &fullPath) override
| Save N tuple to disk. Must be called in order to close the ntuple file properly. More...
StatusCode | save (NTuple::Tuple *tuple) override
| Save N tuple to disk. Must be called in order to close the ntuple file properly. More...
StatusCode | save (DataObject *pParent, const std::string &relPath) override
| Save N tuple to disk. Must be called in order to close the ntuple file properly. More...
StatusCode | writeRecord (NTuple::Tuple *tuple) override
| Write single record to N tuple. More...
StatusCode | writeRecord (const std::string &fullPath) override
| Write single record to N tuple. More...
StatusCode | writeRecord (DataObject *pParent, const std::string &relPath) override
| Write single record to N tuple. More...
StatusCode | readRecord (NTuple::Tuple *tuple) override
| Read single record from N tuple. More...
StatusCode | readRecord (const std::string &fullPath) override
| Read single record from N tuple. More...
StatusCode | readRecord (DataObject *pParent, const std::string &relPath) override
| Read single record from N tuple. More...
bool | isConnected (const std::string &identifier) const override
| Check if a datasource is connected. More...
StatusCode | connect (const std::string &ident) override
| Add file to list I/O list. More...
StatusCode | connect (const std::string &ident, std::string &logname) override
| Add file to list I/O list. More...
StatusCode | disconnect (const std::string &nam) override
| Close open connection. More...
StatusCode | disconnectAll () override
| Close all open connections. More...
| NTupleSvc (const std::string &name, ISvcLocator *svc)
| Standard Constructor. More...
Public Member Functions inherited from extends< DataSvc, INTupleSvc, IDataSourceMgr >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from DataSvc
CLID | rootCLID () const override
| IDataManagerSvc: Accessor for root event CLID. More...
const std::string & | rootName () const override
| IDataManagerSvc: Accessor for root event name. More...
StatusCode | registerAddress (std::string_view fullPath, IOpaqueAddress *pAddress) override
| IDataManagerSvc: Register object address with the data store. More...
StatusCode | registerAddress (IRegistry *parentObj, std::string_view objectPath, IOpaqueAddress *pAddress) override
| IDataManagerSvc: Register object address with the data store. More...
StatusCode | unregisterAddress (std::string_view fullPath) override
| IDataManagerSvc: Unregister object address from the data store. More...
StatusCode | unregisterAddress (IRegistry *pParent, std::string_view objPath) override
| IDataManagerSvc: Unregister object address from the data store. More...
StatusCode | objectLeaves (const DataObject *pObject, std::vector< IRegistry * > &refLeaves) override
| IDataManagerSvc: Explore the object store: retrieve all leaves attached to the object. More...
StatusCode | objectLeaves (const IRegistry *pRegistry, std::vector< IRegistry * > &refLeaves) override
| IDataManagerSvc: Explore the object store: retrieve all leaves attached to the object. More...
StatusCode | objectParent (const DataObject *pObject, IRegistry *&refpParent) override
| IDataManagerSvc: Explore the object store: retrieve the object's parent. More...
StatusCode | objectParent (const IRegistry *pRegistry, IRegistry *&refpParent) override
| IDataManagerSvc: Explore the object store: retrieve the object's parent. More...
StatusCode | clearSubTree (std::string_view sub_tree_path) override
| IDataManagerSvc: Remove all data objects below the sub tree identified by its full path name. More...
StatusCode | clearSubTree (DataObject *pObject) override
| IDataManagerSvc: Remove all data objects below the sub tree identified by the object. More...
StatusCode | clearStore () override
| IDataManagerSvc: Remove all data objects in the data store. More...
StatusCode | traverseSubTree (std::string_view sub_tree_path, IDataStoreAgent *pAgent) override
| IDataManagerSvc: Analyze by traversing all data objects below the sub tree identified by its full path name. More...
StatusCode | traverseSubTree (DataObject *pObject, IDataStoreAgent *pAgent) override
| IDataManagerSvc: Analyze by traversing all data objects below the sub tree. More...
StatusCode | traverseTree (IDataStoreAgent *pAgent) override
| IDataManagerSvc: Analyze by traversing all data objects in the data store. More...
StatusCode | setRoot (std::string root_name, DataObject *pRootObj) override
| Initialize data store for new event by giving new event path and root object. More...
virtual StatusCode | i_setRoot (std::string root_name, DataObject *pRootObj)
| Initialize data store for new event by giving new event path and root object. More...
StatusCode | setRoot (std::string root_path, IOpaqueAddress *pRootAddr) override
| Initialize data store for new event by giving new event path and address of root object. More...
virtual StatusCode | i_setRoot (std::string root_path, IOpaqueAddress *pRootAddr)
| Initialize data store for new event by giving new event path and address of root object. More...
StatusCode | setDataLoader (IConversionSvc *svc, IDataProviderSvc *dpsvc=nullptr) override
| IDataManagerSvc: IDataManagerSvc: Pass a default data loader to the service and optionally a data provider. More...
StatusCode | addPreLoadItem (const DataStoreItem &item) override
| Add an item to the preload list. More...
StatusCode | removePreLoadItem (const DataStoreItem &item) override
| Remove an item from the preload list. More...
StatusCode | resetPreLoad () override
| Clear the preload list. More...
virtual StatusCode | preLoad (int depth, int load_depth, DataObject *pObject)
| Execute one level of preloading and recursively load until the final level is reached. More...
StatusCode | preLoad () override
| load all preload items of the list More...
StatusCode | registerObject (std::string_view parentPath, std::string_view objPath, DataObject *pObject) override
| Register object with the data store. More...
StatusCode | registerObject (DataObject *parentObj, std::string_view objPath, DataObject *pObject) override
| Register object with the data store. More...
StatusCode | unregisterObject (std::string_view fullPath) override
| Unregister object from the data store. More...
StatusCode | unregisterObject (DataObject *pObject) override
| Unregister object from the data store. More...
StatusCode | unregisterObject (DataObject *pObject, std::string_view objectPath) override
| Unregister object from the data store. More...
StatusCode | retrieveObject (IRegistry *pDirectory, std::string_view path, DataObject *&pObject) override
| Retrieve object from data store. More...
StatusCode | findObject (std::string_view fullPath, DataObject *&pObject) override
| Find object identified by its full path in the data store. More...
StatusCode | findObject (IRegistry *pDirectory, std::string_view path, DataObject *&pObject) override
| Find object identified by its full path in the data store. More...
StatusCode | linkObject (IRegistry *from, std::string_view objPath, DataObject *to) override
| Add a link to another object. More...
StatusCode | linkObject (std::string_view fullPath, DataObject *to) override
| Add a link to another object. More...
StatusCode | unlinkObject (IRegistry *from, std::string_view objPath) override
| Remove a link to another object. More...
StatusCode | unlinkObject (DataObject *fromObj, std::string_view objPath) override
| Remove a link to another object. More...
StatusCode | unlinkObject (std::string_view fullPath) override
| Remove a link to another object. More...
StatusCode | updateObject (IRegistry *pDirectory) override
| Update object identified by its directory entry. More...
StatusCode | updateObject (DataObject *toUpdate) override
| Update object. More...
StatusCode | initialize () override
| Service initialization. More...
StatusCode | reinitialize () override
| Service initialization. More...
StatusCode | finalize () override
| Service initialization. More...
| DataSvc (const DataSvc &)=delete
| copy constructor disabled More...
DataSvc & | operator= (const DataSvc &)=delete
| Fake assignment operator (never implemented). More...
virtual StatusCode | registerAddress (std::string_view fullPath, IOpaqueAddress *pAddress)=0
| Register object address with the data store. More...
StatusCode | registerAddress (DataObject *parentObj, std::string_view objectPath, IOpaqueAddress *pAddress)
| Register object address with the data store. More...
virtual StatusCode | registerAddress (IRegistry *parentObj, std::string_view objectPath, IOpaqueAddress *pAddress)=0
| Register object address with the data store. More...
virtual StatusCode | unregisterAddress (std::string_view fullPath)=0
| Unregister object address from the data store. More...
StatusCode | unregisterAddress (DataObject *pParent, std::string_view objPath)
| Unregister object address from the data store. More...
virtual StatusCode | unregisterAddress (IRegistry *pParent, std::string_view objPath)=0
| Unregister object address from the data store. More...
StatusCode | registerObject (std::string_view fullPath, DataObject *pObject)
| Register object with the data store. More...
virtual StatusCode | registerObject (std::string_view parentPath, std::string_view objectPath, DataObject *pObject)=0
| Register object with the data store. More...
StatusCode | registerObject (std::string_view parentPath, int item, DataObject *pObject)
| Register object with the data store. More...
virtual StatusCode | registerObject (DataObject *parentObj, std::string_view objectPath, DataObject *pObject)=0
| Register object with the data store. More...
StatusCode | registerObject (DataObject *parentObj, int item, DataObject *pObject)
| Register object with the data store. More...
virtual StatusCode | retrieveObject (IRegistry *pDirectory, std::string_view path, DataObject *&pObject)=0
| Retrieve object identified by its directory entry. More...
StatusCode | retrieveObject (std::string_view fullPath, DataObject *&pObject)
| Retrieve object identified by its full path from the data store. More...
StatusCode | retrieveObject (std::string_view parentPath, std::string_view objectPath, DataObject *&pObject)
| Retrieve object from data store. More...
StatusCode | retrieveObject (std::string_view parentPath, int item, DataObject *&pObject)
| Retrieve object from data store. More...
StatusCode | retrieveObject (DataObject *parentObj, std::string_view objectPath, DataObject *&pObject)
| Retrieve object from data store. More...
StatusCode | retrieveObject (DataObject *parentObj, int item, DataObject *&pObject)
| Retrieve object from data store. More...
virtual StatusCode | findObject (IRegistry *pDirectory, std::string_view path, DataObject *&pObject)=0
| Find object identified by its directory entry. More...
virtual StatusCode | findObject (std::string_view fullPath, DataObject *&pObject)=0
| Find object identified by its full path in the data store. More...
StatusCode | findObject (std::string_view parentPath, std::string_view objectPath, DataObject *&pObject)
| Find object identified by its parent object and the path to the object relative to the parent. More...
StatusCode | findObject (std::string_view parentPath, int item, DataObject *&pObject)
| Find object identified by its parent object and an integer identifier in the data store. More...
StatusCode | findObject (DataObject *parentObj, std::string_view objectPath, DataObject *&pObject)
| Find object identified by its parent object and the path to the object relative to the parent. More...
StatusCode | findObject (DataObject *parentObj, int item, DataObject *&pObject)
| Find object identified by its parent object and an integer identifier in the data store. More...
virtual StatusCode | linkObject (IRegistry *from, std::string_view objPath, DataObject *toObj)=0
| Add a link to another object. More...
StatusCode | linkObject (std::string_view fromPath, std::string_view objPath, DataObject *toObj)
| Add a link to another object. More...
StatusCode | linkObject (DataObject *fromObj, std::string_view objPath, DataObject *toObj)
| Add a link to another object. More...
virtual StatusCode | linkObject (std::string_view fullPath, DataObject *toObj)=0
| Add a link to another object. More...
virtual StatusCode | unlinkObject (IRegistry *from, std::string_view objPath)=0
| Remove a link to another object. More...
StatusCode | unlinkObject (std::string_view fromPath, std::string_view objPath)
| Remove a link to another object. More...
virtual StatusCode | unlinkObject (DataObject *fromObj, std::string_view objPath)=0
| Remove a link to another object. More...
virtual StatusCode | unlinkObject (std::string_view fullPath)=0
| Remove a link to another object. More...
Public Member Functions inherited from extends< Service, IDataProviderSvc, IDataManagerSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Protected Member Functions
StatusCode | connect (const std::string &ident, std::string &logname) override
| Add file to list I/O list. More...
virtual StatusCode | createService (const std::string &nam, const std::string &typ, const std::vector< Prop > &props, IConversionSvc *&pSvc)
| Create conversion service. More...
Protected Member Functions inherited from NTupleSvc
StatusCode | createService (const std::string &nam, const std::string &typ, const std::vector< Prop > &props, IConversionSvc *&pSvc)
| Create conversion service. More...
void | releaseConnection (Connection &c)
| Finalize single service. More...
StatusCode | attachTuple (const std::string &filename, const std::string &logname, const char typ, const long t)
| Attach output/input file. More...
StatusCode | updateDirectories ()
| Update directory data. More...
Protected Member Functions inherited from DataSvc
bool | checkRoot ()
| Check if root path is valid. More...
virtual DataObject * | createDefaultObject () const
| Create default objects in case forced creation of leaves is requested. More...
virtual StatusCode | loadObject (IRegistry *pNode)
| Invoke Persistency service to create transient object from its persistent representation. More...
virtual StatusCode | loadObject (IConversionSvc *pLoader, IRegistry *pNode)
| Invoke Persistency service to create transient object from its persistent representation. More...
StatusCode | retrieveEntry (DataSvcHelpers::RegistryEntry *pNode, std::string_view path, DataSvcHelpers::RegistryEntry *&pEntry)
| Retrieve registry entry from store. More...
DataObject * | handleDataFault (IRegistry *pReg, std::string_view path="")
| Invoke data fault handling if enabled. More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Additional Inherited Members
Public Types inherited from extends< DataSvc, INTupleSvc, IDataSourceMgr >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from extends< Service, IDataProviderSvc, IDataManagerSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Types inherited from NTupleSvc
typedef std::vector< std::string > | DBaseEntries
typedef std::pair< std::string, std::string > | Prop
Protected Attributes inherited from NTupleSvc
Gaudi::Property< DBaseEntries > | m_input {this, "Input", {}, "input streams"}
Gaudi::Property< DBaseEntries > | m_output {this, "Output", {}, "output streams"}
std::map< std::string, Connection > | m_connections
| Container of connection points. More...
Protected Attributes inherited from DataSvc
SmartIF< IIncidentSvc > | m_incidentSvc = nullptr
| Pointer to incident service. More...
Gaudi::Property< CLID > | m_rootCLID {this, "RootCLID", 110 , "CLID of root entry"}
Gaudi::Property< std::string > | m_rootName {this, "RootName", "/Event", "name of root entry"}
std::unique_ptr< DataSvcHelpers::RegistryEntry > | m_root
| Pointer to root entry. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Gaudi tag collection service definition.

Description: See the base class definition files for more detailed documentation of the implementing class. The basic functionality of the implementation is enhanced to allow for more general N-tuples, which can be used also as event tag collections.

@Author M.Frank @Version 1.0

Definition at line 26 of file TagCollectionSvc.h.

## Constructor & Destructor Documentation

## ◆ TagCollectionSvc()

TagCollectionSvc::TagCollectionSvc | ( | const std::string & | name,
|  | ISvcLocator * | svc
| ) |  |

Standard Constructor.

Definition at line 46 of file TagCollectionSvc.cpp.

46 : NTupleSvc( name, svc ) {}
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274
NTupleSvc::NTupleSvc
NTupleSvc(const std::string &name, ISvcLocator *svc)
Standard Constructor.
Definition: NTupleSvc.cpp:51

## Member Function Documentation

## ◆ connect() [1/3]

StatusCode NTupleSvc::connect
| override

unhides some NTupleSvc methods

Definition at line 180 of file NTupleSvc.cpp.

180 {
181 std::string logName;
182 return connect( ident, logName );
183 }
std::string
STL class.
TagCollectionSvc::connect
StatusCode connect(const std::string &ident, std::string &logname) override
Add file to list I/O list.
Definition: TagCollectionSvc.cpp:49

## ◆ connect() [2/3]

StatusCode NTupleSvc::connect
| override

unhides some NTupleSvc methods

Definition at line 185 of file NTupleSvc.cpp.

185 {
186 DataObject* pO = nullptr;
187 StatusCode status = findObject( m_rootName.value(), pO );
188 if ( status.isSuccess() ) {
189 char typ = 0;
190 std::vector<Prop> props;
191 long loc = ident.find( " " );
192 std::string filename, auth, svc = "", db_typ = "";
193 logname = ident.substr( 0, loc );
194 using Parser = Gaudi::Utils::AttribStringParser;
195 // we assume that there is always a " "
196 // (but if it is not there, we probably will not match the pattern)
197 for ( auto attrib : Parser( ident.substr( loc + 1 ) ) ) {
198 switch ( ::toupper( attrib.tag[0] ) ) {
199 case 'A':
200 break;
201 case 'F': // FILE='<file name>'
202 case 'D': // DATAFILE='<file name>'
203 filename = std::move( attrib.value );
204 break;
205 case 'O': // OPT='<NEW<CREATE,WRITE>, UPDATE, READ>'
206 switch ( ::toupper( attrib.value[0] ) ) {
207 case 'C':
208 case 'N':
209 case 'W':
210 typ = 'N';
211 break;
212 case 'U':
213 typ = 'U';
214 break;
215 case 'O':
216 case 'R':
217 typ = 'O';
218 break;
219 default:
220 typ = 0;
221 break;
222 }
223 break;
224 case 'T': // TYP='<HBOOK,ROOT,OBJY,...>'
225 db_typ = std::move( attrib.value );
226 break;
227 default:
228 props.emplace_back( attrib.tag, attrib.value );
229 break;
230 }
231 }
232 if ( 0 != typ ) {
233 IConversionSvc* pSvc = nullptr;
234 status = createService( name() + '.' + logname, db_typ, props, pSvc );
235 if ( status.isSuccess() ) {
236 status = attachTuple( filename, logname, typ, pSvc->repSvcType() );
237 if ( status.isSuccess() ) {
238 m_connections.insert( {m_rootName + '/' + logname, Connection( pSvc )} );
239 return StatusCode::SUCCESS;
240 }
241 }
242 }
243 }
244 error() << "Cannot add " << ident << " invalid filename!" << endmsg;
245 return StatusCode::FAILURE;
246 }
Gaudi::Utils::AttribStringParser
Parse attribute strings allowing iteration over the various attributes.
Definition: AttribStringParser.h:30
IConversionSvc
Definition: IConversionSvc.h:37
DataSvc::m_rootName
Gaudi::Property< std::string > m_rootName
Definition: DataSvc.h:52
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
NTupleSvc::m_connections
std::map< std::string, Connection > m_connections
Container of connection points.
Definition: NTupleSvc.h:118
graphanalysis.filename
string filename
Definition: graphanalysis.py:119
std::string
STL class.
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
IConverter::repSvcType
virtual long repSvcType() const =0
Retrieve the class type of the data store the converter uses.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
std::move
T move(T... args)
std::vector
STL class.
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
DataSvc::findObject
StatusCode findObject(std::string_view fullPath, DataObject *&pObject) override
Find object identified by its full path in the data store.
Definition: DataSvc.cpp:640
NTupleSvc::attachTuple
StatusCode attachTuple(const std::string &filename, const std::string &logname, const char typ, const long t)
Attach output/input file.
Definition: NTupleSvc.cpp:426
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
toupper
void toupper(std::string &s)
Definition: StatusCodeSvc.cpp:7
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
TagCollectionSvc::createService
virtual StatusCode createService(const std::string &nam, const std::string &typ, const std::vector< Prop > &props, IConversionSvc *&pSvc)
Create conversion service.
Definition: TagCollectionSvc.cpp:151
std::vector::emplace_back
T emplace_back(T... args)

## ◆ connect() [3/3]

StatusCode TagCollectionSvc::connect | ( | const std::string & | ident,
|  | std::string & | logname
| ) |  |
| override protected

Add file to list I/O list.

Definition at line 49 of file TagCollectionSvc.cpp.

49 {
50 DataObject* pO = nullptr;
51 StatusCode status = findObject( m_rootName.value(), pO );
52 if ( status.isSuccess() ) {
53 status = Status::INVALID_ROOT;
54 if ( pO->registry() ) {
55 char typ = 0;
56 std::vector<Prop> props;
57 long loc = ident.find( " " );
58 std::string filename, svc = "DbCnvSvc";
59 logname = ident.substr( 0, loc );
60 using Parser = Gaudi::Utils::AttribStringParser;
61 // we assume that there is always a " "
62 // (but if it is not there, we probably will not match the pattern)
63 for ( auto attrib : Parser( ident.substr( loc + 1 ) ) ) {
64 switch ( ::toupper( attrib.tag[0] ) ) {
65 case 'A':
66 props.emplace_back( "Server", attrib.value );
67 break;
68 case 'F': /* FILE='<file name>' */
69 case 'D': /* DATAFILE='<file name>' */
70 filename = std::move( attrib.value );
71 break;
72 case 'O': /* OPT='<NEW<CREATE,WRITE>, UPDATE, READ>' */
73 switch ( ::toupper( attrib.value[0] ) ) {
74 case 'C':
75 case 'N':
76 case 'W':
77 typ = 'N';
78 break;
79 case 'U':
80 typ = 'U';
81 break;
82 case 'O':
83 case 'R':
84 switch ( ::toupper( attrib.value[2] ) ) {
85 case 'C': /* RECREATE */
86 typ = 'R';
87 break;
88 case 'A': /* READ */
89 default:
90 typ = 'O';
91 break;
92 }
93 break;
94 default:
95 typ = 0;
96 break;
97 }
98 break;
99 case 'S': // SVC='<service type>'
100 switch ( ::toupper( attrib.tag[1] ) ) {
101 case 'V':
102 svc = std::move( attrib.value );
103 break;
104 case 'H':
105 switch ( ::toupper( attrib.value[0] ) ) {
106 case 'Y':
107 props.emplace_back( "ShareFiles", attrib.value );
108 break;
109 }
110 break;
111 }
112 break;
113 case 'T': // TYP='<HBOOK,ROOT,OBJY,...>'
114 switch ( ::toupper( attrib.value[0] ) ) {
115 case 'H':
116 svc = "HbookCnv::ConvSvc";
117 break;
118 case 'P':
119 props.emplace_back( "DbType", attrib.value );
120 svc = "PoolDbCnvSvc";
121 break;
122 default:
123 props.emplace_back( "DbType", attrib.value );
124 svc = "DbCnvSvc";
125 break;
126 }
127 break;
128 default:
129 props.emplace_back( attrib.tag, attrib.value );
130 break;
131 }
132 }
133 if ( 0 != typ ) {
134 IConversionSvc* pSvc = nullptr;
135 status = createService( name() + '.' + logname, svc, props, pSvc );
136 if ( status.isSuccess() ) {
137 status = attachTuple( filename, logname, typ, pSvc->repSvcType() );
138 if ( status.isSuccess() ) {
139 m_connections.emplace( m_rootName + '/' + logname, Connection( pSvc ) );
140 return StatusCode::SUCCESS;
141 }
142 }
143 }
144 }
145 }
146 error() << "Cannot add " << ident << " invalid filename!" << endmsg;
147 return StatusCode::FAILURE;
148 }
Gaudi::Utils::AttribStringParser
Parse attribute strings allowing iteration over the various attributes.
Definition: AttribStringParser.h:30
DataObject::registry
IRegistry * registry() const
Get pointer to Registry.
Definition: DataObject.h:72
IConversionSvc
Definition: IConversionSvc.h:37
DataSvc::m_rootName
Gaudi::Property< std::string > m_rootName
Definition: DataSvc.h:52
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
NTupleSvc::m_connections
std::map< std::string, Connection > m_connections
Container of connection points.
Definition: NTupleSvc.h:118
graphanalysis.filename
string filename
Definition: graphanalysis.py:119
std::string
STL class.
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
IConverter::repSvcType
virtual long repSvcType() const =0
Retrieve the class type of the data store the converter uses.
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isSuccess
bool isSuccess() const
Definition: StatusCode.h:267
std::move
T move(T... args)
std::string::find
T find(T... args)
std::vector
STL class.
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
std::string::substr
T substr(T... args)
DataSvc::findObject
StatusCode findObject(std::string_view fullPath, DataObject *&pObject) override
Find object identified by its full path in the data store.
Definition: DataSvc.cpp:640
NTupleSvc::attachTuple
StatusCode attachTuple(const std::string &filename, const std::string &logname, const char typ, const long t)
Attach output/input file.
Definition: NTupleSvc.cpp:426
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
toupper
void toupper(std::string &s)
Definition: StatusCodeSvc.cpp:7
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
TagCollectionSvc::createService
virtual StatusCode createService(const std::string &nam, const std::string &typ, const std::vector< Prop > &props, IConversionSvc *&pSvc)
Create conversion service.
Definition: TagCollectionSvc.cpp:151
std::vector::emplace_back
T emplace_back(T... args)

## ◆ createService()

StatusCode TagCollectionSvc::createService | ( | const std::string & | nam,
|  | const std::string & | typ,
|  | const std::vector< Prop > & | props,
|  | IConversionSvc *& | pSvc
| ) |  |
| protected virtual

Create conversion service.

Parameters

  nam | Name of the service to be created
  svc | Service type if sepecified in the options
  props |

Definition at line 151 of file TagCollectionSvc.cpp.

152 {
153 pSvc = nullptr;
154 using Gaudi::Utils::TypeNameString;
155 auto mgr = serviceLocator()->as<ISvcManager>();
156
157 // TagCollectionSvc has to directly create a ConversionSvc to manage it directly.
158 StatusCode status = IInterface::Status::NO_INTERFACE;
159 if ( mgr ) {
160 SmartIF<IService> isvc = mgr->createService( TypeNameString( nam, typ ) );
161 if ( isvc ) {
162 auto icsvc = isvc.as<IConversionSvc>();
163 if ( icsvc ) {
164 auto iprop = isvc.as<IProperty>();
165 if ( iprop ) {
166 for ( const auto& p : props ) { iprop->setProperty( p.first, p.second ).ignore(); }
167 // NTupleSvc has to directly create a ConversionSvc to manage it directly.
168 status = isvc->sysInitialize();
169 if ( status.isSuccess() ) {
170 status = icsvc->setDataProvider( this );
171 if ( status.isSuccess() ) {
172 pSvc = icsvc.get();
173 pSvc->addRef();
174 }
175 }
176 }
177 }
178 }
179 }
180 return status;
181 }
IInterface::Status::NO_INTERFACE
Requested interface is not available.
SmartIF< IService >
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:277
IConversionSvc
Definition: IConversionSvc.h:37
ISvcManager
The ISvcManager is the interface implemented by the Service Factory in the Application Manager to sup...
Definition: ISvcManager.h:28
SmartIF::as
SmartIF< IFace > as() const
return a new SmartIF instance to another interface
Definition: SmartIF.h:107
ISvcLocator::as
SmartIF< IFace > as()
Definition: ISvcLocator.h:103
IService::sysInitialize
virtual StatusCode sysInitialize()=0
Initialize Service.
IProperty::setProperty
virtual StatusCode setProperty(const Gaudi::Details::PropertyBase &p)=0
Set the property by property.
Gaudi::Utils::TypeNameString
Helper class to parse a string of format "type/name".
Definition: TypeNameString.h:10
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::ignore
const StatusCode & ignore() const
Ignore/check StatusCode.
Definition: StatusCode.h:153
IInterface::addRef
virtual unsigned long addRef()=0
Increment the reference count of Interface instance.
IProperty
The IProperty is the basic interface for all components which have properties that can be set or get.
Definition: IProperty.h:20

The documentation for this class was generated from the following files:

- GaudiSvc/src/NTupleSvc/TagCollectionSvc.h
- GaudiSvc/src/NTupleSvc/TagCollectionSvc.cpp